#ifndef bqt65asmDataAreaHH
#define bqt65asmDataAreaHH

#include <map>
#include <vector>

class DataArea
{
    typedef std::vector<unsigned char> vec;
    typedef std::map<unsigned, vec> map;
    map blobs;
private:
    vec& GetRef(unsigned offset, unsigned& base);
    static void PrepareVec(vec&, unsigned offset);
public:
    void WriteByte(unsigned pos, unsigned char byte);
    unsigned char GetByte(unsigned pos) const;
    
    unsigned GetBase() const;
    unsigned GetTop() const;
    unsigned GetSize() const { return GetTop() - GetBase(); }

    const std::vector<unsigned char> GetContent() const;
};

#endif
